Index: src/java/org/jivesoftware/spark/ui/ContactItem.java
===================================================================
--- src/java/org/jivesoftware/spark/ui/ContactItem.java	(revision 10873)
+++ src/java/org/jivesoftware/spark/ui/ContactItem.java	(working copy)
@@ -39,529 +37,628 @@
 /**
  * Represent a single contact within the <code>ContactList</code>.
  */
-public class ContactItem extends JPanel {
-    private JLabel imageLabel;
-    private JLabel displayNameLabel;
-    private JLabel descriptionLabel;
-    private String nickname;
-    private String alias;
-    private String fullyQualifiedJID;
-    private Icon icon;
-
-    private String status;
-    private String groupName;
+public class ContactItem extends JPanel
+{
+	private JLabel		imageLabel;
+	private JLabel		displayNameLabel;
+	private JLabel		descriptionLabel;
+	private String		nickname;
+	private String		alias;
+	private String		fullyQualifiedJID;
+	private Icon		icon;
 
-    boolean available;
+	private String		status;
+	private String		groupName;
 
-    private Presence presence;
+	boolean				available;
 
-    private String hash = "";
+	private Presence	presence;
 
-    private File contactsDir;
+	private String		hash	= "";
 
-    private JLabel sideIcon;
+	private File		contactsDir;
 
-    private int fontSize;
+	private JLabel		sideIcon;
 
-    private int iconSize;
+	private int			fontSize;
 
-    private boolean avatarsShowing;
+	private int			iconSize;
 
-    /**
-     * Creates a new instance of a contact.
-     *
-     * @param alias             the alias of the contact
-     * @param nickname          the nickname of the contact.
-     * @param fullyQualifiedJID the fully-qualified jid of the contact (ex. derek@jivesoftware.com)
-     */
-    public ContactItem(String alias, String nickname, String fullyQualifiedJID) {
-        setLayout(new GridBagLayout());
+	private boolean	avatarsShowing;
 
-        // Set Default Font
-        final LocalPreferences pref = SettingsManager.getLocalPreferences();
-        fontSize = pref.getContactListFontSize();
-        iconSize = pref.getContactListIconSize();
-        avatarsShowing = pref.areAvatarsVisible();
+	/**
+	 * Creates a new instance of a contact.
+	 * 
+	 * @param alias
+	 *           the alias of the contact
+	 * @param nickname
+	 *           the nickname of the contact.
+	 * @param fullyQualifiedJID
+	 *           the fully-qualified jid of the contact (ex.
+	 *           derek@jivesoftware.com)
+	 */
+	public ContactItem(String alias, String nickname, String fullyQualifiedJID)
+	{
+		setLayout(new GridBagLayout());
 
-        // Set default presence
-        presence = new Presence(Presence.Type.unavailable);
+		// Set Default Font
+		final LocalPreferences pref = SettingsManager.getLocalPreferences();
+		fontSize = pref.getContactListFontSize();
+		iconSize = pref.getContactListIconSize();
+		avatarsShowing = pref.areAvatarsVisible();
 
-        contactsDir = new File(SparkManager.getUserDirectory(), "contacts");
+		// Set default presence
+		presence = new Presence(Presence.Type.unavailable);
 
-        displayNameLabel = new JLabel();
-        descriptionLabel = new JLabel();
-        imageLabel = new JLabel();
-        sideIcon = new JLabel();
-        if (avatarsShowing) {
-            sideIcon.setMinimumSize(new Dimension(iconSize, iconSize));
-            sideIcon.setMaximumSize(new Dimension(iconSize, iconSize));
-            sideIcon.setPreferredSize(new Dimension(iconSize, iconSize));
-        }
+		contactsDir = new File(SparkManager.getUserDirectory(), "contacts");
 
-        displayNameLabel.setHorizontalTextPosition(JLabel.LEFT);
-        displayNameLabel.setHorizontalAlignment(JLabel.LEFT);
-        //displayNameLabel.setText(nickname);
+		displayNameLabel = new JLabel();
+		descriptionLabel = new JLabel();
+		imageLabel = new JLabel();
+		sideIcon = new JLabel();
+		if (avatarsShowing)
+		{
+			sideIcon.setMinimumSize(new Dimension(iconSize, iconSize));
+			sideIcon.setMaximumSize(new Dimension(iconSize, iconSize));
+			sideIcon.setPreferredSize(new Dimension(iconSize, iconSize));
+		}
 
+		displayNameLabel.setHorizontalTextPosition(JLabel.LEFT);
+		displayNameLabel.setHorizontalAlignment(JLabel.LEFT);
+		// displayNameLabel.setText(nickname);
 
-        descriptionLabel.setFont(new Font("Dialog", Font.PLAIN, fontSize));
-        descriptionLabel.setForeground((Color)UIManager.get("ContactItemDescription.foreground"));
-        descriptionLabel.setHorizontalTextPosition(JLabel.LEFT);
-        descriptionLabel.setHorizontalAlignment(JLabel.LEFT);
+		descriptionLabel.setFont(new Font("Dialog", Font.PLAIN, fontSize));
+		descriptionLabel.setForeground((Color) UIManager.get("ContactItemDescription.foreground"));
+		descriptionLabel.setHorizontalTextPosition(JLabel.LEFT);
+		descriptionLabel.setHorizontalAlignment(JLabel.LEFT);
 
+		this.setOpaque(true);
 
-        this.setOpaque(true);
+		add(imageLabel, new GridBagConstraints(0, 0, 1, 2, 0.0, 0.0, GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(0, 15, 0, 0), 0, 0));
+		add(displayNameLabel, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 5, 0, 0), 0, 0));
+		add(descriptionLabel, new GridBagConstraints(2, 0, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 5, 2, 0), 0, 0));
+		add(sideIcon, new GridBagConstraints(3, 0, 1, 2, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 5, 0, 0), 0, 0));
 
-        add(imageLabel, new GridBagConstraints(0, 0, 1, 2, 0.0, 0.0, GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(0, 15, 0, 0), 0, 0));
-        add(displayNameLabel, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 5, 0, 0), 0, 0));
-        add(descriptionLabel, new GridBagConstraints(2, 0, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 5, 2, 0), 0, 0));
-        add(sideIcon, new GridBagConstraints(3, 0, 1, 2, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 5, 0, 0), 0, 0));
+		this.alias = alias;
+		this.nickname = nickname;
+		this.fullyQualifiedJID = fullyQualifiedJID;
 
-        this.alias = alias;
-        this.nickname = nickname;
-        this.fullyQualifiedJID = fullyQualifiedJID;
-        
-        setDisplayName();
-    }
+		setDisplayName();
+	}
 
 	/**
-	 * Returns the name that should be displayed to represent the the contact.
-	 * If an alias has been set, this alias will be returned. If no alias has
-	 * been set, the nickname will be returned. If that hasn't been set either,
-	 * the JID will be returned.
+	 * Returns the name that should be displayed to represent the the contact. If
+	 * an alias has been set, this alias will be returned. If no alias has been
+	 * set, the nickname will be returned. If that hasn't been set either, the
+	 * JID will be returned.
 	 * 
 	 * @return a name suitable to be displayed
 	 */
-    public String getDisplayName() {
-    	final String displayName;
-		if (alias != null) {
+	public String getDisplayName()
+	{
+		final String displayName;
+		if (alias != null)
+		{
 			displayName = alias;
-		} else if (nickname != null) {
+		}
+		else if (nickname != null)
+		{
 			displayName = nickname;
-		} else {
+		}
+		else
+		{
 			displayName = getJID();
 		}
-		
-		if (displayName != null) {
-		return displayName;
-		} else {
+
+		if (displayName != null)
+		{
+			return displayName;
+		}
+		else
+		{
 			return ""; // weird, but happens.
 		}
 	}
 
-    /**
+	/**
 	 * Returns the nickname of the contact. Note that for typical user-interface
 	 * related tasks, you probably should use {@link #getDisplayName()} instead.
 	 * 
 	 * @return the contact nickname.
 	 */
-	public String getNickname() {
+	public String getNickname()
+	{
 		return nickname;
 	}
-	
-    /**
-     * Sets the nickname of the contact.
-     *
-     * @param nickname the contact nickname.
-     */
-    public void setNickname(String nickname) {
-        this.nickname = nickname;
-        if (alias == null) {
-        	setDisplayName();
-        }
-    }
+
+	/**
+	 * Sets the nickname of the contact.
+	 * 
+	 * @param nickname
+	 *           the contact nickname.
+	 */
+	public void setNickname(String nickname)
+	{
+		this.nickname = nickname;
+		if (alias == null)
+		{
+			setDisplayName();
+		}
+	}
 
-    /**
+	/**
 	 * Returns the alias of the contact. Note that for typical user-interface
 	 * related tasks, you probably should use {@link #getDisplayName()} instead.
 	 * 
 	 * @return the contact alias.
 	 */
-	public String getAlias() {
+	public String getAlias()
+	{
 		return alias;
 	}
-    
-    /**
-     * Sets the alias of the contact. 
-     *
-     * @param alias the contact alias.
-     */
-    public void setAlias(String alias) {
-    	this.alias = alias;
-    	setDisplayName();
-    }
+
+	/**
+	 * Sets the alias of the contact.
+	 * 
+	 * @param alias
+	 *           the contact alias.
+	 */
+	public void setAlias(String alias)
+	{
+		this.alias = alias;
+		setDisplayName();
+	}
 
-    /**
+	/**
 	 * Updates the displayed name for the contact. This method tries to use an
 	 * alias first. If that's not set, the nickname will be used instead. If
 	 * that's not set either, the JID of the user will be used.
 	 */
-    private void setDisplayName() {
-    	final String displayName = getDisplayName();
-    	
-        int nickLength = displayName.length();
-        
-        LayoutSettings settings = LayoutSettingsManager.getLayoutSettings();
-        int windowWidth = (int)Math.round((settings.getMainWindowHeight() / 15.2));
-        
-        if (nickLength > windowWidth) {
-            displayNameLabel.setText(StringUtils.unescapeNode(displayName).substring(0, windowWidth) + "...");
-        } else {
-            displayNameLabel.setText(StringUtils.unescapeNode(displayName));
-        }    	
-    }
-    
-    /**
-     * Returns the fully qualified JID of the contact. (If available). Otherwise will
-     * return the bare jid.
-     *
-     * @return the fully qualified jid (ex. derek@jivesoftware.com).
-     */
-    public String getJID() {
-        return fullyQualifiedJID;
-    }
+	private void setDisplayName()
+	{
+		final String displayName = getDisplayName();
 
-    /**
-     * Returns the icon showing the contacts current state or presence.
-     *
-     * @return the icon.
-     */
-    public Icon getIcon() {
-        return icon;
-    }
+		int nickLength = displayName.length();
 
-    /**
-     * Sets the current icon to use.
-     *
-     * @param icon the current icon to use.
-     */
-    public void setIcon(Icon icon) {
-        this.icon = icon;
-        imageLabel.setIcon(icon);
-    }
+		LayoutSettings settings = LayoutSettingsManager.getLayoutSettings();
+		int windowWidth = (int) Math.round((settings.getMainWindowHeight() / 15.2));
 
-    /**
-     * Returns the contacts current status based on their presence.
-     *
-     * @return the contacts current status.
-     */
-    public String getStatus() {
-        return status;
-    }
+		if (nickLength > windowWidth)
+		{
+			displayNameLabel.setText(StringUtils.unescapeNode(displayName).substring(0, windowWidth)
+				+ "...");
+		}
+		else
+		{
+			displayNameLabel.setText(StringUtils.unescapeNode(displayName));
+		}
+	}
 
-    /**
-     * Sets the contacts current status.
-     *
-     * @param status the contacts current status.
-     */
-    public void setStatus(String status) {
-        this.status = status;
-    }
+	/**
+	 * Returns the fully qualified JID of the contact. (If available). Otherwise
+	 * will return the bare jid.
+	 * 
+	 * @return the fully qualified jid (ex. derek@jivesoftware.com).
+	 */
+	public String getJID()
+	{
+		return fullyQualifiedJID;
+	}
 
-    /**
-     * Returns the name of the <code>ContactGroup</code> that this contact belongs to.
-     *
-     * @return the name of the <code>ContactGroup</code>.
-     */
-    public String getGroupName() {
-        return groupName;
-    }
+	/**
+	 * Returns the icon showing the contacts current state or presence.
+	 * 
+	 * @return the icon.
+	 */
+	public Icon getIcon()
+	{
+		return icon;
+	}
 
-    /**
-     * Sets the name of the <code>ContactGrouop</code> that this contact belongs to.
-     *
-     * @param groupName the name of the ContactGroup.
-     */
-    public void setGroupName(String groupName) {
-        this.groupName = groupName;
-    }
+	/**
+	 * Sets the current icon to use.
+	 * 
+	 * @param icon
+	 *           the current icon to use.
+	 */
+	public void setIcon(Icon icon)
+	{
+		this.icon = icon;
+		imageLabel.setIcon(icon);
+	}
 
-    public boolean isAvailable() {
-        return available;
-    }
+	/**
+	 * Returns the contacts current status based on their presence.
+	 * 
+	 * @return the contacts current status.
+	 */
+	public String getStatus()
+	{
+		return status;
+	}
 
-    public void setAvailable(boolean available) {
-        this.available = available;
-    }
+	/**
+	 * Sets the contacts current status.
+	 * 
+	 * @param status
+	 *           the contacts current status.
+	 */
+	public void setStatus(String status)
+	{
+		this.status = status;
+	}
 
-    /**
-     * Returns the <code>JLabel</code> showing the users nickname.
-     *
-     * @return the nickname label.
-     */
-    public JLabel getNicknameLabel() {
-        return displayNameLabel;
-    }
+	/**
+	 * Returns the name of the <code>ContactGroup</code> that this contact
+	 * belongs to.
+	 * 
+	 * @return the name of the <code>ContactGroup</code>.
+	 */
+	public String getGroupName()
+	{
+		return groupName;
+	}
 
-    /**
-     * Returns the <code>JLabel</code> representing the description.
-     *
-     * @return the description label.
-     */
-    public JLabel getDescriptionLabel() {
-        return descriptionLabel;
-    }
+	/**
+	 * Sets the name of the <code>ContactGrouop</code> that this contact belongs
+	 * to.
+	 * 
+	 * @param groupName
+	 *           the name of the ContactGroup.
+	 */
+	public void setGroupName(String groupName)
+	{
+		this.groupName = groupName;
+	}
 
-    /**
-     * Returns the current presence of the contact.
-     *
-     * @return the users current presence.
-     */
-    public Presence getPresence() {
-        return presence;
-    }
+	public boolean isAvailable()
+	{
+		return available;
+	}
 
-    /**
-     * Sets the current presence on this contact item.
-     *
-     * @param presence the presence.
-     */
-    public void setPresence(Presence presence) {
+	public void setAvailable(boolean available)
+	{
+		this.available = available;
+	}
 
-        this.presence = presence;
+	/**
+	 * Returns the <code>JLabel</code> showing the users nickname.
+	 * 
+	 * @return the nickname label.
+	 */
+	public JLabel getNicknameLabel()
+	{
+		return displayNameLabel;
+	}
 
-        final PacketExtension packetExtension = presence.getExtension("x", "vcard-temp:x:update");
+	/**
+	 * Returns the <code>JLabel</code> representing the description.
+	 * 
+	 * @return the description label.
+	 */
+	public JLabel getDescriptionLabel()
+	{
+		return descriptionLabel;
+	}
 
-        // Handle vCard update packet.
-        if (packetExtension != null) {
-            DefaultPacketExtension o = (DefaultPacketExtension)packetExtension;
-            String hash = o.getValue("photo");
-            if (hash != null) {
-                this.hash = hash;
+	/**
+	 * Returns the current presence of the contact.
+	 * 
+	 * @return the users current presence.
+	 */
+	public Presence getPresence()
+	{
+		return presence;
+	}
 
-                if (!hashExists(hash)) {
-                    updateAvatar();
-                }
+	/**
+	 * Sets the current presence on this contact item.
+	 * 
+	 * @param presence
+	 *           the presence.
+	 */
+	public void setPresence(Presence presence)
+	{
 
-                updateAvatarInSideIcon();
-            }
-        }
+		this.presence = presence;
 
-        updatePresenceIcon(presence);
-    }
+		final PacketExtension packetExtension = presence.getExtension("x", "vcard-temp:x:update");
 
-    /**
-     * Checks to see if the hash already exists.
-     *
-     * @param hash the hash.
-     * @return true if the hash exists, otherwise false.
-     */
-    private boolean hashExists(String hash) {
-        contactsDir.mkdirs();
+		// Handle vCard update packet.
+		if (packetExtension != null)
+		{
+			DefaultPacketExtension o = (DefaultPacketExtension) packetExtension;
+			String hash = o.getValue("photo");
+			if (hash != null)
+			{
+				this.hash = hash;
 
-        final File imageFile = new File(contactsDir, hash);
-        return imageFile.exists();
-    }
+				if (!hashExists(hash))
+				{
+					updateAvatar();
+				}
 
-    /**
-     * Returns the url of the avatar belonging to this contact.
-     *
-     * @return the url of the avatar.
-     * @throws MalformedURLException thrown if the address is invalid.
-     */
-    public URL getAvatarURL() throws MalformedURLException {
-        contactsDir.mkdirs();
+				updateAvatarInSideIcon();
+			}
+		}
+		updatePresenceIcon(presence);
+	}
 
-        if (ModelUtil.hasLength(hash)) {
-            final File imageFile = new File(contactsDir, hash);
-            if (imageFile.exists()) {
-                return imageFile.toURL();
-            }
-        }
+	/**
+	 * Checks to see if the hash already exists.
+	 * 
+	 * @param hash
+	 *           the hash.
+	 * @return true if the hash exists, otherwise false.
+	 */
+	private boolean hashExists(String hash)
+	{
+		contactsDir.mkdirs();
 
-        return SparkManager.getVCardManager().getAvatarURL(getJID());
-    }
+		final File imageFile = new File(contactsDir, hash);
+		return imageFile.exists();
+	}
 
-    /**
-     * Persists the avatar locally based on the new hash.
-     */
-    private void updateAvatar() {
-        SparkManager.getVCardManager().addToQueue(getJID());
-    }
+	/**
+	 * Returns the url of the avatar belonging to this contact.
+	 * 
+	 * @return the url of the avatar.
+	 * @throws MalformedURLException
+	 *            thrown if the address is invalid.
+	 */
+	public URL getAvatarURL() throws MalformedURLException
+	{
+		contactsDir.mkdirs();
 
-    public String toString() {
-        return displayNameLabel.getText();
-    }
+		if (ModelUtil.hasLength(hash))
+		{
+			final File imageFile = new File(contactsDir, hash);
+			if (imageFile.exists()) { return imageFile.toURL(); }
+		}
 
+		return SparkManager.getVCardManager().getAvatarURL(getJID());
+	}
 
-    /**
-     * Updates the icon of the user based on their presence.
-     *
-     * @param presence the users presence.
-     */
-    public void updatePresenceIcon(Presence presence) {
-        ChatManager chatManager = SparkManager.getChatManager();
-        boolean handled = chatManager.fireContactItemPresenceChanged(this, presence);
-        if (handled) {
-            return;
-        }
+	/**
+	 * Persists the avatar locally based on the new hash.
+	 */
+	private void updateAvatar()
+	{
+		SparkManager.getVCardManager().addToQueue(getJID());
+	}
 
-        String status = presence.getStatus();
-        Icon statusIcon = SparkRes.getImageIcon(SparkRes.GREEN_BALL);
-        boolean isAvailable = false;
-        if (status == null && presence.isAvailable()) {
-            Presence.Mode mode = presence.getMode();
-            if (mode == Presence.Mode.available) {
-                status = Res.getString("status.available");
-                isAvailable = true;
-            }
-            else if (mode == Presence.Mode.away) {
-                status = Res.getString("status.away");
-                statusIcon = SparkRes.getImageIcon(SparkRes.IM_AWAY);
-            }
-            else if (mode == Presence.Mode.chat) {
-                status = Res.getString("status.free.to.chat");
-            }
-            else if (mode == Presence.Mode.dnd) {
-                status = Res.getString("status.do.not.disturb");
-                statusIcon = SparkRes.getImageIcon(SparkRes.IM_AWAY);
-            }
-            else if (mode == Presence.Mode.xa) {
-                status = Res.getString("status.extended.away");
-                statusIcon = SparkRes.getImageIcon(SparkRes.IM_AWAY);
-            }
-        }
+	public String toString()
+	{
+		return displayNameLabel.getText();
+	}
 
-        if (presence.isAvailable() && (presence.getMode() == Presence.Mode.dnd || presence.getMode() == Presence.Mode.away || presence.getMode() == Presence.Mode.xa)) {
-            statusIcon = SparkRes.getImageIcon(SparkRes.IM_AWAY);
-        }
-        else if (presence.isAvailable()) {
-            isAvailable = true;
-        }
-        else if (!presence.isAvailable()) {
-            getNicknameLabel().setFont(new Font("Dialog", Font.PLAIN, fontSize));
-            getNicknameLabel().setForeground((Color)UIManager.get("ContactItemOffline.color"));
+	/**
+	 * Updates the icon of the user based on their presence.
+	 * 
+	 * @param presence
+	 *           the users presence.
+	 */
+	public void updatePresenceIcon(Presence presence)
+	{
+		JFrame externalizedFrame = SparkManager.getExternalizedFrame(getAlias());
+		ChatRoomImpl chatroom = (ChatRoomImpl) SparkManager.getExternalizedChatRoom(getAlias());	
+		ChatManager chatManager = SparkManager.getChatManager();
+		boolean handled = chatManager.fireContactItemPresenceChanged(this, presence);
+		if (handled) { return; }
+		String status = presence.getStatus();
+		Icon statusIcon = SparkRes.getImageIcon(SparkRes.GREEN_BALL);
+		boolean isAvailable = false;
+		if (status == null && presence.isAvailable())
+		{
+			Presence.Mode mode = presence.getMode();
+			if (mode == Presence.Mode.available)
+			{
+				status = Res.getString("status.available");
+				isAvailable = true;
+			}
+			else if (mode == Presence.Mode.away)
+			{
+				status = Res.getString("status.away");
+				statusIcon = SparkRes.getImageIcon(SparkRes.IM_AWAY);
+			}
+			else if (mode == Presence.Mode.chat)
+			{
+				status = Res.getString("status.free.to.chat");
+			}
+			else if (mode == Presence.Mode.dnd)
+			{
+				status = Res.getString("status.do.not.disturb");
+				statusIcon = SparkRes.getImageIcon(SparkRes.IM_AWAY);
+			}
+			else if (mode == Presence.Mode.xa)
+			{
+				status = Res.getString("status.extended.away");
+				statusIcon = SparkRes.getImageIcon(SparkRes.IM_AWAY);
+			}
+		}
 
-            RosterEntry entry = SparkManager.getConnection().getRoster().getEntry(getJID());
-            if (entry != null && (entry.getType() == RosterPacket.ItemType.none || entry.getType() == RosterPacket.ItemType.from)
-                    && RosterPacket.ItemStatus.SUBSCRIPTION_PENDING == entry.getStatus()) {
-                // Do not move out of group.
-                setIcon(SparkRes.getImageIcon(SparkRes.SMALL_QUESTION));
-                getNicknameLabel().setFont(new Font("Dialog", Font.PLAIN, fontSize));
-                setStatusText(Res.getString("status.pending"));
-            }
-            else {
-                setIcon(null);
-                setFont(new Font("Dialog", Font.PLAIN, fontSize));
-                getNicknameLabel().setFont(new Font("Dialog", Font.PLAIN, fontSize));
-                setAvailable(false);
-                if (ModelUtil.hasLength(status)) {
-                    setStatusText(status);
-                }
-                else {
-                    setStatusText("");
-                }
-            }
+		if (presence.isAvailable()
+			&& (presence.getMode() == Presence.Mode.dnd
+				|| presence.getMode() == Presence.Mode.away || presence.getMode() == Presence.Mode.xa))
+		{
+			statusIcon = SparkRes.getImageIcon(SparkRes.IM_AWAY);
+		}
+		else if (presence.isAvailable())
+		{
+			isAvailable = true;
+		}
+		else if (!presence.isAvailable())
+		{
+			getNicknameLabel().setFont(new Font("Dialog", Font.PLAIN, fontSize));
+			getNicknameLabel().setForeground((Color) UIManager.get("ContactItemOffline.color"));
 
-            sideIcon.setIcon(null);
-            setAvailable(false);
-            return;
-        }
+			RosterEntry entry = SparkManager.getConnection().getRoster().getEntry(getJID());
+			if (entry != null
+				&& (entry.getType() == RosterPacket.ItemType.none || entry.getType() == RosterPacket.ItemType.from)
+				&& RosterPacket.ItemStatus.SUBSCRIPTION_PENDING == entry.getStatus())
+			{
+				// Do not move out of group.
+				setIcon(SparkRes.getImageIcon(SparkRes.SMALL_QUESTION));
+				getNicknameLabel().setFont(new Font("Dialog", Font.PLAIN, fontSize));
+				setStatusText(Res.getString("status.pending"));
+			}
+			else
+			{
+				setIcon(null);
+				setFont(new Font("Dialog", Font.PLAIN, fontSize));
+				getNicknameLabel().setFont(new Font("Dialog", Font.PLAIN, fontSize));
+				setAvailable(false);
+				if (ModelUtil.hasLength(status))
+				{
+					setStatusText(status);
+				}
+				else
+				{
+					setStatusText("");
+				}
+			}
 
-        Icon sIcon = PresenceManager.getIconFromPresence(presence);
-        if (sIcon != null) {
-            setIcon(sIcon);
-        }
-        else {
-            setIcon(statusIcon);
-        }
-        if (status != null) {
-            setStatus(status);
-        }
+			sideIcon.setIcon(null);
+			setAvailable(false);
+			
+			if(externalizedFrame != null)
+				externalizedFrame.setIconImage(SparkRes.getImageIcon(SparkRes.CLEAR_BALL_ICON).getImage());
+			
+			return;
+		}
 
-        if (status != null && status.toLowerCase().indexOf("phone") != -1) {
-            statusIcon = SparkRes.getImageIcon(SparkRes.ON_PHONE_IMAGE);
-            setIcon(statusIcon);
-        }
+		Icon sIcon = PresenceManager.getIconFromPresence(presence);
+		if (sIcon != null)
+		{
+			setIcon(sIcon);
+		}
+		else
+		{
+			setIcon(statusIcon);
+		}
+		if (status != null)
+		{
+			setStatus(status);
+		}
 
-        // Always change nickname label to black.
-        getNicknameLabel().setForeground((Color)UIManager.get("ContactItemNickname.foreground"));
+		if (status != null && status.toLowerCase().indexOf("phone") != -1)
+		{
+			statusIcon = SparkRes.getImageIcon(SparkRes.ON_PHONE_IMAGE);
+			setIcon(statusIcon);
+		}
 
+		// Always change nickname label to black.
+		getNicknameLabel().setForeground((Color) UIManager.get("ContactItemNickname.foreground"));
 
-        if (isAvailable) {
-            getNicknameLabel().setFont(new Font("Dialog", Font.PLAIN, fontSize));
-            if (Res.getString("status.online").equals(status) || Res.getString("available").equalsIgnoreCase(status)) {
-                setStatusText("");
-            }
-            else {
-                setStatusText(status);
-            }
-        }
-        else if (presence.isAvailable()) {
-            getNicknameLabel().setFont(new Font("Dialog", Font.ITALIC, fontSize));
-            getNicknameLabel().setForeground(Color.gray);
-            if (status != null) {
-                setStatusText(status);
-            }
-        }
+		if (isAvailable)
+		{
+			getNicknameLabel().setFont(new Font("Dialog", Font.PLAIN, fontSize));
+			if (Res.getString("status.online").equals(status)
+				|| Res.getString("available").equalsIgnoreCase(status))
+			{
+				setStatusText("");
+			}
+			else
+			{
+				setStatusText(status);
+			}
+		}
+		else if (presence.isAvailable())
+		{
+			getNicknameLabel().setFont(new Font("Dialog", Font.ITALIC, fontSize));
+			getNicknameLabel().setForeground(Color.gray);
+			if (status != null)
+			{
+				setStatusText(status);
+			}
+		}
 
-        setAvailable(true);
-    }
+		setAvailable(true);
+		
+		if (externalizedFrame != null)
+		{
+			externalizedFrame.setIconImage(((ImageIcon) (SparkManager.getContactList().getContactItemByJID(chatroom.getParticipantJID())).getIcon()).getImage());
+		}
+	}
 
-    /**
-     * Sets the status label text based on the users status.
-     *
-     * @param status the users status.
-     */
-    public void setStatusText(String status) {
-        setStatus(status);
+	/**
+	 * Sets the status label text based on the users status.
+	 * 
+	 * @param status
+	 *           the users status.
+	 */
+	public void setStatusText(String status)
+	{
+		setStatus(status);
 
-        if (ModelUtil.hasLength(status)) {
-            getDescriptionLabel().setText(" - " + status);
-        }
-        else {
-            getDescriptionLabel().setText("");
-        }
-    }
+		if (ModelUtil.hasLength(status))
+		{
+			getDescriptionLabel().setText(" - " + status);
+		}
+		else
+		{
+			getDescriptionLabel().setText("");
+		}
+	}
 
-    /**
-     * The icon to use to show extra information about this contact. An example would be to
-     * represent that this user is from a 3rd party transport.
-     *
-     * @param icon the icon to use.
-     */
-    public void setSideIcon(Icon icon) {
-        sideIcon.setIcon(icon);
-    }
+	/**
+	 * The icon to use to show extra information about this contact. An example
+	 * would be to represent that this user is from a 3rd party transport.
+	 * 
+	 * @param icon
+	 *           the icon to use.
+	 */
+	public void setSideIcon(Icon icon)
+	{
+		sideIcon.setIcon(icon);
+	}
 
-    /**
-     * Shows that the user is coming online.
-     */
-    public void showUserComingOnline() {
-        // Change Font
-        getNicknameLabel().setFont(new Font("Dialog", Font.BOLD, fontSize));
-        getNicknameLabel().setForeground(new Color(255, 128, 0));
-    }
+	/**
+	 * Shows that the user is coming online.
+	 */
+	public void showUserComingOnline()
+	{
+		// Change Font
+		getNicknameLabel().setFont(new Font("Dialog", Font.BOLD, fontSize));
+		getNicknameLabel().setForeground(new Color(255, 128, 0));
+	}
 
-    /**
-     * Shows that the user is going offline.
-     */
-    public void showUserGoingOfflineOnline() {
-        // Change Font
-        getNicknameLabel().setFont(new Font("Dialog", Font.BOLD, fontSize));
-        getNicknameLabel().setForeground(Color.red);
-    }
+	/**
+	 * Shows that the user is going offline.
+	 */
+	public void showUserGoingOfflineOnline()
+	{
+		// Change Font
+		getNicknameLabel().setFont(new Font("Dialog", Font.BOLD, fontSize));
+		getNicknameLabel().setForeground(Color.red);
+	}
 
-    /**
-     * Update avatar icon.
-     */
-    public void updateAvatarInSideIcon() {
-        try {
-            final URL url = getAvatarURL();
-            if (url != null) {
-                if (!avatarsShowing) {
-                    setSideIcon(null);
-                }
-                else {
-                    ImageIcon icon = new ImageIcon(url);
-                    icon = GraphicUtils.scale(icon, iconSize, iconSize);
-                    setSideIcon(icon);
-                }
-            }
-        }
-        catch (MalformedURLException e) {
-            Log.error(e);
-        }
-    }
-
+	/**
+	 * Update avatar icon.
+	 */
+	public void updateAvatarInSideIcon()
+	{
+		try
+		{
+			final URL url = getAvatarURL();
+			if (url != null)
+			{
+				if (!avatarsShowing)
+				{
+					setSideIcon(null);
+				}
+				else
+				{
+					ImageIcon icon = new ImageIcon(url);
+					icon = GraphicUtils.scale(icon, iconSize, iconSize);
+					setSideIcon(icon);
+				}
+			}
+		}
+		catch (MalformedURLException e)
+		{
+			Log.error(e);
+		}
+	}
 
 }
